| Face Engine SDK 5.12.0 A face detection, recognition and tracking engine.

Classes | Macros | Functions
SDK core interfaces

Common interfaces and macros shared across all SDK objects. More...

## Classes
struct | fsdk::IFaceEngine
| Root LUNA SDK object interface. More...
struct | fsdk::IArchive
| Archive interface. More...
struct | fsdk::ISerializableObject
| Serializable object interface. More...
struct | fsdk::ErrorTraits< ISerializableObject::Error >
| Specialized for ISerializableObject::SerializationError. More...
struct | fsdk::IDataStorageObject
| Data storage object interface helper. More...
struct | fsdk::IRefCounted
| Base strong reference counted object interface. More...
struct | fsdk::ISettingsProvider
| SDK settings provider interface. More...
struct | fsdk::ErrorTraits< ISettingsProvider::Error >
| Specialized for ISettingsProvider::ParseError. More...

## Macros
#define | ALIGN_UP(value, align)
#define | ALIGNED(x) __attribute__ ((aligned(x)))
#define | RESTRICT __restrict__
#define | FORCE_INLINE inline __attribute__ ((always_inline))
#define | DECLARE_SMARTPTR(X) struct X; using X##Ptr = fsdk::Ref<X>
| Smart ptr declaration helper macro.
#define | STRINGIFY2(x) #x
| Stringification helper macro.
#define | STRINGIFY(x) STRINGIFY2(x)
| Stringifies it's argument.

## Functions
FSDK_API Result< FSDKError > | fsdk::activateLicense (ILicense *license, const char *configPath) noexcept
| Makes License activation with some platform specific manner. Network connection is required. More...
FSDK_API Result< FSDKError > | fsdk::activateLicense (ILicense *license, ISettingsProvider *settings) noexcept
| Makes License activation with some platform specific manner. Network connection is required. More...
FSDK_API ResultValue< FSDKError, IFaceEnginePtr > | fsdk::createFaceEngine (const char *dataPath=nullptr, const char *configPath=nullptr, const char *runtimePath=nullptr) noexcept
| Create the LUNA SDK root object. More...
FSDK_API ResultValue< FSDKError, ISettingsProviderPtr > | fsdk::createSettingsProvider (const char *path) noexcept
| Creates a settings provider. More...
FSDK_API ResultValue< FSDKError, ISettingsProviderPtr > | fsdk::createSettingsProviderFromString (const char *content) noexcept
| Creates a settings provider from the xml-formatted string. More...

## Detailed Description

Common interfaces and macros shared across all SDK objects.

## Macro Definition Documentation

## ◆ ALIGN_UP

#define ALIGN_UP | ( |  | value,
|  |  | align
| ) |  |

Value:
(((value) & (align-1)) ? \
(((value) + (align-1)) & ~(align-1)) : \
(value))

## Function Documentation

## ◆ activateLicense() [1/2]

FSDK_API Result<FSDKError> fsdk::activateLicense | ( | ILicense * | license,
|  | const char * | configPath
| ) |  |
| noexcept

Makes License activation with some platform specific manner. Network connection is required.

Parameters

  [in] | license | pointer to the license object which should be activated
  [in] | configPath | path to license.conf file with licensing settings.

Returns
  true if license was successfully activated.

## ◆ activateLicense() [2/2]

FSDK_API Result<FSDKError> fsdk::activateLicense | ( | ILicense * | license,
|  | ISettingsProvider * | settings
| ) |  |
| noexcept

Makes License activation with some platform specific manner. Network connection is required.

Parameters

  [in] | license | pointer to the license object which should be activated
  [in] | provider | settings provider.

Returns
  true if license was successfully activated.

## ◆ createFaceEngine()

FSDK_API ResultValue<FSDKError, IFaceEnginePtr> fsdk::createFaceEngine | ( | const char * | dataPath = `nullptr`,
|  | const char * | configPath = `nullptr`,
|  | const char * | runtimePath = `nullptr`
| ) |  |
| noexcept

Create the LUNA SDK root object.

Parameters

  [in] | dataPath | [optional] path to folder with FSDK data. Default: ./data (on windows), /opt/visionlabs/data (on linux)
  [in] | configPath | [optional] path to faceengine.conf file. Default: <dataPath>/faceengine.conf
  [in] | runtimePath | [optional] path to runtime.conf file. Default: <dataPath>/runtime.conf

Returns
  ResultValue with error code and IFaceEnginePtr instance.

See also
  ResultValue, FSDKError, IFaceEnginePtr

## ◆ createSettingsProvider()

FSDK_API fsdk::ResultValue< fsdk::FSDKError, fsdk::ISettingsProviderPtr > fsdk::createSettingsProvider | ( | const char * | path | ) |
| noexcept

Creates a settings provider.

Parameters

  [in] | path | configuration file path

Returns
  Error code;

See also
  FSDKError and settings provider object if succeeded, null if failed.

## ◆ createSettingsProviderFromString()

FSDK_API ResultValue< FSDKError, ISettingsProviderPtr > fsdk::createSettingsProviderFromString | ( | const char * | content | ) |
| noexcept

Creates a settings provider from the xml-formatted string.

Parameters

  [in] | content | content string in xml-format, in a case of nullptr empty config will be created

Returns
  Error code and settings provider object if succeeded, null if failed.

See also
  FSDKError, ISettingsProvider::save